# Tests by default. No tests: rpm -ba --define 'dotests 0' file*.spec
%{!?dotests: %define dotests 1}
Summary: A utility for determining file types
Name: file
Version:	5.45
Release:	1
License: BSD
Group: Applications/File
Source0:	http://ftp.astron.com/pub/file/file-%{version}.tar.gz
Patch0: %{name}-5.38-rpmbuild-hang-fix.patch
Patch1: %{name}-5.39-strip.patch
Patch2: %{name}-5.45-getopt_long.patch

URL: https://www.darwinsys.com/file/

BuildRequires:	zlib-devel
AutoReqProv:    no

%define _libdir64 %{_prefix}/lib64

Requires: %{name}-libs = %{version}-%{release}

%description
The file command is used to identify a particular file according to the
type of data contained by the file.  File can identify many different
file types, including ELF binaries, system libraries, RPM packages, and
different graphics formats.

You should install the file package, since the file command is such a
useful utility.

%package libs
Summary: Libraries for applications using libmagic
Group:   Applications/File
%if %{toolchain} == "gcc"
BuildRequires:	libgcc >= 10.3.0
Requires:	libgcc >= 10.3.0
%endif
Requires:	zlib >= 1.2.13
Requires:	bzip2 >= 1.0.8
Requires:	xz-libs >= 5.4.3

%description libs
Libraries for applications using libmagic.
The library is available as 32-bit and 64-bit.

%package devel
Summary:  Libraries and header files for file development
Group:    Applications/File
Requires: %{name} = %{version}-%{release}

%description devel
The file-devel package contains the header files and libmagic library
necessary for developing programs using libmagic.

%prep
# Don't use -b -- it will lead to poblems when compiling magic file
%setup -q
%patch0 -p0
%patch1 -p0
%patch2 -p1
rm -rf /tmp/%{name}-%{version}-32bit
mkdir  /tmp/%{name}-%{version}-32bit
mv *   /tmp/%{name}-%{version}-32bit
mkdir 32bit
mv     /tmp/%{name}-%{version}-32bit/* 32bit
rm -rf /tmp/%{name}-%{version}-32bit
mkdir 64bit
cp -rp 32bit/* 64bit/

%build
# setup environment for 32-bit and 64-bit
export AR="/usr/bin/ar -X32_64"        
export NM="/usr/bin/nm -X32_64" 
export CC="%{__cc__}"
export CXX="%{__cxx__}"

# work around strange libtool error on AIX6.1, see details at:
# https://www.ibm.com/developerworks/forums/thread.jspa?messageID=14145662
export RM="/usr/bin/rm -f"
# first build the 64-bit version
cd 64bit
export OBJECT_MODE=64 
export LDFLAGS="-L%{_builddir}/%{name}-%{version}/64bit/src/.libs -L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib "
CFLAGS="-maix64 -I/opt/freeware/include/ -D_ALL_SOURCE -D_FILE_OFFSET_BITS=64 -O2 -D_LINUX_SOURCE_COMPAT"  \
CPPFLAGS='-I/opt/freeware/include ' \
./configure --prefix=%{_prefix} \
	   --mandir=%{_mandir} \
           --libdir=%{_libdir64} \
	   --enable-fsect-man5 \
	   --disable-silent-rules \
	   --disable-zstdlib
gmake "V=1" -j8

cp src/.libs/libmagic.so.1 ../32bit 

#make distclean

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

# now build the 32-bit version
cd ../32bit
export OBJECT_MODE=32
export LDFLAGS="-L%{_builddir}/%{name}-%{version}/32bit/src/.libs -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
CFLAGS="-maix32 -I/opt/freeware/include/ -D_ALL_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -O2 -D_LINUX_SOURCE_COMPAT" \
CPPFLAGS='-I/opt/freeware/include ' \
./configure --prefix=%{_prefix} \
	   --mandir=%{_mandir} \
	   --libdir=%{_libdir} \
           --enable-fsect-man5 \
	   --disable-silent-rules \
	   --disable-zstdlib
gmake "V=1" -j8

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
# avoid "busy" error messages...
slibclean
${AR} -q  src/.libs/libmagic.a ./libmagic.so.1

#32bit test suite fails while executing the following test case
#TZ=UTC MAGIC=../magic/magic ./test -e ../tests/fit-map-data.testfile ../tests/fit-map-data.result
#MAX_CTIME is defined as CAST(time_t, 0x3afff487cfULL) in src/file.h and the value 0x3afff487cfULL is outside the range of time_t(long int).
#As a result MAX_CTIME has a negative value and the if condition t>MAX_CTIME(in function file_fmtdatetime in src/print.c)  is satisfied and the 
#test case fails with the error "Invalid datetime"

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
export OBJECT_MODE=64 
cd 64bit
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in *
  do
    mv ${f} ${f}_64
  done
)

cat magic/Magdir/* > ${RPM_BUILD_ROOT}%{_datadir}/misc/magic
ln -s misc/magic ${RPM_BUILD_ROOT}%{_datadir}/magic
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
ln -s ../magic ${RPM_BUILD_ROOT}%{_datadir}/%{name}/magic

export OBJECT_MODE=32
cd ../32bit
gmake DESTDIR=${RPM_BUILD_ROOT} install
/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
    cd  ${RPM_BUILD_ROOT}%{_bindir}
    for f in $(ls -1| grep -v -e _32 -e _64)
    do
        mv $f "$f"_32
        ln -sf "$f"_64 $f
    done
)

%posttrans
# Reinstate the LPP rpm.rte symlink, they have probably been replaced/removed
# Get the LPP rpm.rte version first and check for rpm.rte version because
# rpm.rte >= 4.13.0.4 ships files in "/usr/opt/rpm" path and
# rpm.rte below that level ships files in "/usr/opt/freeware"

ver=$(lslpp -Lc rpm.rte | /usr/bin/awk 'FNR==2' | /usr/bin/awk -F':' '{print $3}')
f1=$(echo $ver | /usr/bin/cut -d"." -f1)
f2=$(echo $ver | /usr/bin/cut -d"." -f2)
f4=$(echo $ver | /usr/bin/cut -d"." -f4)

# 3.0.5.x, 4.9.1.3, 4.13.0.x, 4.15.1.x are the various rpm.rte levels
# It's enough to compare First, Second & Fourth fields against 4.13.0.4

if [[ ( $f1 -gt 4 ) || ( $f1 -eq 4 && ( ( $f2 -gt 13 ) || ( ( $f2 -eq 13 ) && ( $f4 -ge 4 )))) ]]; then
    LINK_PATH="/usr/opt/rpm"
else
    LINK_PATH="/usr/opt/freeware"
fi

if ! test -e /usr/lib/libmagic.a && ! test -h /usr/lib/libmagic.a 
then
  ln -sf ${LINK_PATH}/lib/libmagic.a /usr/lib/libmagic.a
fi


%files
%defattr(-,root,system,-)
%doc 32bit/COPYING 32bit/ChangeLog 
%{_bindir}/*
%{_mandir}/man1/*

%files libs
%defattr(-,root,system,-)
%{_libdir}/*.a
%{_libdir}64/*.a
%{_datadir}/magic*
%{_mandir}/man5/*
%{_datadir}/%{name}
%{_datadir}/misc/*

%files devel
%defattr(-,root,system,-)
%{_includedir}/*
%{_mandir}/man3/*

%changelog
* Wed Jan 17 2024 Reshma V Kumar <reskumar@in.ibm.com> - 5.45-1 
- Update to version 5.45

* Mon May 17 2022 Reshma V Kumar <reskumar@in.ibm.com> - 5.41-1
- Update to 5.41

* Thu Feb 18 2021 Reshma V Kumar <reskumar@in.ibm.com> - 5.39-1
- Update to 5.39
- Stop shipping files in /usr directory

* Thu Apr 16 2020 Baanu Tumma <btumma15@in.ibm.com> 5.38-1
- Updated to latest version

* Mon May 06 2019 Reshma V Kumar <reskumar@in.ibm.com>5.36-1
- Updated to fix CVE-2019-8907,CVE-2019-8904,CVE-2019-8906,CVE-2019-8905

* Wed Dec 26 2018 Reshma V Kumar <reskumar@in.ibm.com>5.32-2
- Rebuild with rpmbuild-hang-fix.patch

* Sat Feb 17 2018 Reshma V Kumar <reskumar@in.ibm.com>5.32-1
- Update to latest version

* Thu Mar 17 2016 Sangamesh Mallayya <smallayy@in.ibm.com> 5.12-2
- Update to 5.12 for AIX Toolbox.

* Thu Jul 04 2013 Gerard Visiedo <gerard.visiedo@bull.net> 5.12-2
-  update to version 5.12. on Aix5.3

* Tue Feb 12 2013 Gerard Visiedo <gerard.visiedo@bull.net> 5.12-1
- update to version 5.12. This version is mandatory for rpm manager 4.9.1.3

* Thu Mar 29 2012 Patricia Cugny <patricia.cugny@bull.net>  5.11-1
- update to version 5.11

* Fri Mar 13 2009 Jean Noel Cordenner <jean-noel.cordenner@bull.net> 5.00-1
- port to AIX



